#include<iostream>
#include<cstdio>
#include<cassert>
#include<cmath>
#include<ctime>
#include<algorithm>
#include<vector> 
#include<cstring>
#include<string>
#include<map>
#include<set>

#define mp make_pair
#define scn second
#define frs first
#define pb push_back

#define NAME "adding"

using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<ll, int> pi;
const int P = 239017;
const ll INF = 1000000000ll * 1000000000;
const int MAX = 2000 + 10;

const int mod = 1e9 + 7;


int n, m;


int main() {
    freopen(NAME ".in", "r", stdin); 
    freopen(NAME ".out", "w", stdout); 
    
    scanf("%d%d", &n, &m);
    vector<vector<ll> > a(n);
    for (int i = 0; i < n; ++i)
    	a[i] = vector<ll>(m);
    for (int i = 0; i < n; ++i)
    	for (int j = 0; j < m; ++j)
    		scanf("%I64d", &a[i][j]);
   	int t;
   	scanf("%d", &t);
   	int x, y;   		
   	if (m <= 300) {
   		while (t --> 0) {   			
   			scanf("%d%d", &x, &y);	
   			x--, y--;
   			for (int i = 0; i < m; ++i)
   				a[x][i] += a[y][i], a[x][i] %= mod;
   	   	}
   	} else {
   		vector<vector<ll> > arr(n);
   		for (int i = 0; i < n; ++i) {
   			arr[i] = vector<ll>(n); 
   			arr[i][i] = 1;
   		}
   		while (t --> 0) {
   			scanf("%d%d", &x, &y);
   			x--, y--;	
   			for (int i = 0; i < n; ++i)
   				arr[x][i] += arr[y][i], arr[x][i] %= mod;	   		
	   	}
	   	vector<vector<ll> > b = a;
	   	for (int i = 0; i < n; ++i)
	   		for (int j = 0; j < m; ++j)
	   			b[i][j] = a[i][j], a[i][j] = 0;
	   	for (int i = 0; i < n; ++i) {
	   		for (int j = 0; j < n; ++j) {
	   			for (int k = 0; k < m; ++k) {
	   			    a[i][k] += (b[j][k] * arr[i][j]) % mod, a[i][k] %= mod;
	   			}	   	 
	   	    }
	   	}	   	
   	}
   	for (int i = 0; i < n; ++i, printf("\n"))
   		for (int j = 0; j < m; ++j)
   			printf("%I64d ", a[i][j]);   	
   	return 0;
}




