#include <cstdio>
#include <iostream>
#include <ctime>
#include <vector>

using namespace std;

const int mod = 1e9 + 7;
const int maxn = 1 << 17;

int n, m, k;
vector<vector<int> > a, b;
int x[maxn], y[maxn];

void solven() {
	b.assign(n, vector<int>(n));
	for (int i = 0; i < n; i++) b[i][i] = 1;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < n; j++) {
			b[x[i]][j] = (b[x[i]][j] + b[y[i]][j]) % mod;
		}
	}
	vector<vector<int> > c = a;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
		  	a[i][j] = 0;
			for (int k = 0; k < n; k++) a[i][j] = (a[i][j] + 1LL * b[i][k] * c[k][j]) % mod;
		}
	}
}

void solvem() {
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < m; j++) {
		 	a[x[i]][j] = (a[x[i]][j] + a[y[i]][j]) % mod;
		}
	}	
}

int main() {
 	freopen("adding.in", "r", stdin);
	freopen("adding.out", "w", stdout);

	scanf("%d%d", &n, &m);
	a.assign(n, vector<int>(m));
	for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) scanf("%d", &a[i][j]);
	scanf("%d", &k);
	for (int i = 0; i < k; i++) scanf("%d%d", &x[i], &y[i]), x[i]--, y[i]--;

	if (n >= m) solvem();
	else solven();

	for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) printf("%d%c", a[i][j], " \n"[j + 1 == m]);

	return 0;
}