import java.util.*;
import java.io.*;

public class adding_iz {
	static final int MOD = (int)1e9 + 7;

	static void solven(int n, int m, int k, int a[][], int x[], int y[]) {
		int b[][] = new int[n][n];
		for (int i = 0; i < n; i++) b[i][i] = 1;
		for (int i = 0; i < k; i++) {
		 	for (int j = 0; j < n; j++) {
		 	 	b[x[i]][j] = (b[x[i]][j] + b[y[i]][j]) % MOD;
			}
		}
		int c[][] = new int[n][m];
		for (int i = 0; i < n; i++) {
		 	for (int j = 0; j < m; j++) {
				c[i][j] = 0;
				for (int l = 0; l < n; l++) {
				 	c[i][j] = (int)((c[i][j] + 1L * a[l][j] * b[i][l]) % MOD);
				}
			}
		}
		for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) a[i][j] = c[i][j];
	}

	static void solvem(int n, int m, int k, int a[][], int x[], int y[]) {
		for (int i = 0; i < k; i++) {
		 	for (int j = 0; j < m; j++) {
		 	 	a[x[i]][j] = (a[x[i]][j] + a[y[i]][j]) % MOD;
			}
		}
	}

 	public static void main(String[] args) throws IOException {
 	 	Scanner in = new Scanner(new File("adding.in"));
		PrintWriter out = new PrintWriter(new File("adding.out"));

		int n = in.nextInt();
		int m = in.nextInt();
		int a[][] = new int[n][m];
		for (int i = 0; i < n; i++) {
		 	for (int j = 0; j < m; j++) {
		 	 	a[i][j] = in.nextInt();
			}
		}
		int k = in.nextInt();
		int x[] = new int[k];
		int y[] = new int[k];
		for (int i = 0; i < k; i++) {
		 	x[i] = in.nextInt() - 1;
			y[i] = in.nextInt() - 1;
		}

		if (n >= m) {
		    solvem(n, m, k, a, x, y);    
		} else {
		 	solven(n, m, k, a, x, y);
		}
		for (int i = 0; i < n; i++) {
		 	for (int j = 0; j < m; j++) {
		 	 	out.print(a[i][j]);
				if (j + 1 == m) {
				 	out.println();
				} else {
					out.print(" ");
				}
			}
		}
		out.close();
	}
}